using System;


namespace CheckSumAdjuster
{
    class Program
    {
        /// <summary>
        /// vO̎spX
        /// </summary>
        public static string execpath = string.Empty;
        /// <summary>
        /// `FbNTt@C
        /// </summary>
        private const string csumfile = "csum.xml";
        /// <summary>
        /// `FbNTvZJnʒu
        /// </summary>
        private static int[] begin;
        /// <summary>
        /// `FbNTvZ͈
        /// </summary>
        private static int[] size;
        /// <summary>
        /// `FbNTAhX
        /// </summary>
        private static int[] address;
        /// <summary>
        /// `FbNTl
        /// </summary>
        private static int[] value;
        /// <summary>
        /// Z[uf[^
        /// </summary>
        private static byte[] save;


        /// <summary>
        /// `FbNTCB
        /// </summary>
        private static void AdjustChecksum()
        {
            for (int i = 0; i < begin.Length; i++)
            {
                int csum = save[address[i]] + save[address[i] + 1] + save[address[i] + 2] + save[address[i] + 3];
                if (csum != 0)
                {
                    int sum = value[i];
                    for (int j = 0; j < size[i]; j += 4)
                    {
                        int baseaddr = begin[i] + j;
                        sum += save[baseaddr];
                        sum += save[++baseaddr] << 8;
                        sum += save[++baseaddr] << 16;
                        sum += save[++baseaddr] << 24;
                    }
                    int csumaddr = address[i];
                    save[csumaddr] = (byte)(0xFF & sum);
                    save[++csumaddr] = (byte)(0xFF & (sum >> 8));
                    save[++csumaddr] = (byte)(0xFF & (sum >> 16));
                    save[++csumaddr] = (byte)(0xFF & (sum >> 24));
                    Console.WriteLine(System.Convert.ToString(sum, 16).ToUpper());
                }
            }
        }


        /// <summary>
        /// CheckSumAdjustersB
        /// </summary>
        /// <param name="args">Z[uf[^̃t@CpX</param>
        public static void Main(string[] args)
        {
            InitExecpath();
            InitChecksum();

            save = System.IO.File.ReadAllBytes(args[0]);
            AdjustChecksum();

            System.IO.File.WriteAllBytes(args[0], save);
        }


        /// <summary>
        /// sAhX擾B
        /// </summary>
        private static void InitExecpath()
        {
            execpath = System.Windows.Forms.Application.StartupPath;
            if (execpath.EndsWith("\\") == false)
            {
                execpath += "\\";
            }
        }


        /// <summary>
        /// `FbNTǂݍށB
        /// </summary>
        private static void InitChecksum()
        {
            System.Xml.XmlDocument document = new System.Xml.XmlDocument();
            document.Load(execpath + csumfile);
            System.Xml.XmlNodeList host = document.GetElementsByTagName("checksum");
            begin = new int[host.Count];
            size = new int[host.Count];
            address = new int[host.Count];
            value = new int[host.Count];
            for (int i = 0; i < host.Count; i++)
            {
                begin[i] = int.Parse(host[i].Attributes["begin"].InnerText);
                size[i] = int.Parse(host[i].Attributes["size"].InnerText);
                address[i] = int.Parse(host[i].Attributes["address"].InnerText);
                value[i] = int.Parse(host[i].Attributes["value"].InnerText);
            }
        }


    }
}
